package org.jboss.security.auth.callback;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.lang.reflect.Method;
import java.security.Principal;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;
import org.jboss.security.auth.callback.ObjectCallback;
import org.jboss.security.auth.callback.SecurityAssociationCallback;

public class SecurityAssociationHandler implements CallbackHandler {
  private transient Principal principal;
  
  private transient Object credential;
  
  public SecurityAssociationHandler() {}
  
  public SecurityAssociationHandler(Principal principal, Object credential) {
    this.principal = principal;
    this.credential = credential;
  }
  
  public void setSecurityInfo(Principal principal, Object credential) {
    this.principal = principal;
    this.credential = credential;
  }
  
  public void handle(Callback[] callbacks) throws UnsupportedCallbackException {
    for (int i = 0; i < callbacks.length; i++) {
      Callback c = callbacks[i];
      if (c instanceof SecurityAssociationCallback) {
        SecurityAssociationCallback sac = (SecurityAssociationCallback)c;
        sac.setPrincipal(this.principal);
        sac.setCredential(this.credential);
      } else if (c instanceof ObjectCallback) {
        ObjectCallback oc = (ObjectCallback)c;
        oc.setCredential(this.credential);
      } else if (c instanceof NameCallback) {
        NameCallback nc = (NameCallback)c;
        if (this.principal != null)
          nc.setName(this.principal.getName()); 
      } else if (c instanceof PasswordCallback) {
        PasswordCallback pc = (PasswordCallback)c;
        char[] password = getPassword();
        if (password != null)
          pc.setPassword(password); 
      } else {
        throw new UnsupportedCallbackException(c, "Unrecognized Callback");
      } 
    } 
  }
  
  private char[] getPassword() {
    char[] password = null;
    if (this.credential instanceof char[]) {
      password = (char[])this.credential;
    } else if (this.credential instanceof String) {
      String s = (String)this.credential;
      password = s.toCharArray();
    } else {
      try {
        Class[] types = new Class[0];
        Method m = this.credential.getClass().getMethod("toCharArray", types);
        Object[] args = new Object[0];
        password = (char[])m.invoke(this.credential, args);
      } catch (Exception e) {
        if (this.credential != null) {
          String s = this.credential.toString();
          password = s.toCharArray();
        } 
      } 
    } 
    return password;
  }
}
